; TSCWin 1.0 util by falco



; --------------------------------------------------------------- Include Files
%INCLUDE "..\..\inc\win32n.inc"

; ------------------------------------------------------------ Import Functions
EXTERN SetProcessAffinityMask 
IMPORT SetProcessAffinityMask kernel32.dll
EXTERN SetPriorityClass 
IMPORT SetPriorityClass kernel32.dll
EXTERN GetCurrentProcess
IMPORT GetCurrentProcess kernel32.dll
EXTERN QueryPerformanceFrequency
IMPORT QueryPerformanceFrequency kernel32.dll
EXTERN QueryPerformanceCounter
IMPORT QueryPerformanceCounter kernel32.dll
EXTERN MessageBoxA
IMPORT MessageBoxA user32.dll
EXTERN ExitProcess
IMPORT ExitProcess kernel32.dll

; ================================================================ Code Section
SECTION CODE USE32 CLASS=CODE
..start:

PUSHFD       ;CPUID DETECT
POP EAX
MOV EBX,EAX
BTC EAX,21
PUSH EAX
POPFD
PUSHFD
POP EAX
CMP EAX,EBX
JZ NEAR @NOSUPPORT

MOV EAX,1    ;RDTSC DETECT
CPUID
MOV EAX,4
BT EDX,EAX
JNC NEAR @NOSUPPORT

PUSH DWORD PFREQ
CALL [QueryPerformanceFrequency] ;HIGH-RES TIMER SUPPORT
CMP EAX,0
JE NEAR @NOSUPPORT

CALL [GetCurrentProcess]

PUSH EAX

PUSH DWORD 1
PUSH EAX
CALL [SetProcessAffinityMask]

POP EAX

PUSH REALTIME_PRIORITY_CLASS
PUSH EAX
CALL [SetPriorityClass]

CPUID
RDTSC

MOV [REAX],EAX
MOV [REDX],EDX

PUSH DWORD PCOUNT
CALL [QueryPerformanceCounter]

MOV EAX,[PFREQ+LARGE_INTEGER.lowpart]
MOV EDX,[PFREQ+LARGE_INTEGER.highpart]
MOV ECX,10
DIV ECX
XOR EDX,EDX

ADD EAX,[PCOUNT+LARGE_INTEGER.lowpart]
ADC EDX,[PCOUNT+LARGE_INTEGER.highpart]

@LOOP1
PUSH EAX
PUSH EDX
PUSH DWORD PCOUNT2
CALL [QueryPerformanceCounter]
POP EDX
POP EAX
CMP EDX,[PCOUNT2+LARGE_INTEGER.highpart]
JA @LOOP1
CMP EAX,[PCOUNT2+LARGE_INTEGER.lowpart]
JA @LOOP1

CPUID
RDTSC

SUB EAX,[REAX]
SBB EDX,[REDX]

MOV ECX,10000
DIV ECX

CALL PRINTNUMBER

PUSH UINT MB_OK
PUSH LPCTSTR TITLE1
PUSH LPCTSTR STRING1
PUSH HWND NULL
CALL [MessageBoxA]

PUSH UINT 0
CALL [ExitProcess]

@NOSUPPORT:
PUSH UINT MB_OK
PUSH LPCTSTR TITLE1
PUSH LPCTSTR NOSUPP1
PUSH HWND NULL
CALL [MessageBoxA]

PUSH UINT 0
CALL [ExitProcess]


PRINTNUMBER 
    MOV ECX, 0
    MOV EBX, 10
@LOOPHERE:
    MOV EDX, 0
    DIV EBX                         
                       
    PUSH EAX
    ADD DL, '0'                    

    POP EAX
    PUSH EDX                        
    INC ECX                         
    CMP EAX, 0
JNZ @LOOPHERE
    
    MOV EDI,MHZ1 
@LOOPHERE2:
    POP EDX
    CMP ECX,1
    JNE @NODOT
    MOV BYTE [EDI],'.'
    INC EDI
    @NODOT:
    MOV BYTE [EDI],DL
    INC EDI
    LOOP @LOOPHERE2
    MOV BYTE [EDI],0
    RET


SECTION DATA USE32 CLASS=DATA

REAX DD 0
REDX DD 0

PFREQ:
istruc LARGE_INTEGER
at LARGE_INTEGER.lowpart, dd 0
at LARGE_INTEGER.highpart, dd 0
iend

PCOUNT:
istruc LARGE_INTEGER
at LARGE_INTEGER.lowpart, dd 0
at LARGE_INTEGER.highpart, dd 0
iend

PCOUNT2:
istruc LARGE_INTEGER
at LARGE_INTEGER.lowpart, dd 0
at LARGE_INTEGER.highpart, dd 0
iend


TITLE1 DB 'TSCWin 1.0 by Falcosoft',0
NOSUPP1 DB 'CPU is not supported!',0
STRING1 DB 'CPU speed in MHz: '
MHZ1 RESB 32
